/*
 *  TOPPERS ATK2
 *      Toyohashi Open Platform for Embedded Real-Time Systems
 *      Automotive Kernel Version 2
 *
 *  Copyright (C) 2008-2013 by Center for Embedded Computing Systems
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *  Copyright (C) 2011-2013 by FUJISOFT INCORPORATED, JAPAN
 *  Copyright (C) 2011-2013 by FUJITSU VLSI LIMITED, JAPAN
 *  Copyright (C) 2011-2013 by NEC Communication Systems, Ltd., JAPAN
 *  Copyright (C) 2011-2013 by Panasonic Advanced Technology Development Co., Ltd., JAPAN
 *  Copyright (C) 2011-2013 by Renesas Electronics Corporation, JAPAN
 *  Copyright (C) 2011-2013 by Sunny Giken Inc., JAPAN
 *  Copyright (C) 2011-2013 by TOSHIBA CORPORATION, JAPAN
 *  Copyright (C) 2011-2013 by Witz Corporation, JAPAN
 *
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 *
 *  $Id: avalon_timer.c 7284 2013-03-29 06:18:22Z fujitsu-wada $
 */

/*
 *		ޥɥ饤СAvalon Timer
 */

#include "kernel_impl.h"
#include "target_timer.h"
#include "avalon_timer.h"
#include "Os_Lcfg.h"

/*
 *  ߤΥƥñ: ߥá
 *
 *  ̩ˤϡΥƥåΥƥ
 */
static SystemTimeMsType current_time;

/*
 *  ޥñ̤Ǥλ
 */
SystemTimeUsType
get_tim_utime(void)
{
	SystemTimeUsType	utime;
	SystemTimeMsType	mtime;
	TickType			clock1, clock2;
	boolean				ireq;
	SIL_PRE_LOC;

	SIL_LOC_INT();
	mtime = current_time;
	clock1 = target_timer_get_current();
	ireq = target_timer_probe_int();
	clock2 = target_timer_get_current();
	SIL_UNL_INT();
	utime = ((SystemTimeUsType) mtime) * 1000U;

	if ((ireq != FALSE) && (clock2 > clock1)) {
		utime += 1000U;
	}
	utime += TO_USEC(clock1);
	return(utime);
}

/*
 *  ޤεư
 */
void
target_timer_initialize(void)
{
	current_time = 0U;

	/* ޡȥå */
	sil_wrw_iop((void *) (SYS_CLK_TIMER_BASE + AVALON_TIM_CONTROL), AVALON_TIM_CONTROL_STOP);
	/* ॢȥơꥢ */
	sil_wrw_iop((void *) (SYS_CLK_TIMER_BASE + AVALON_TIM_STATUS), 0x00U);

	sil_wrw_iop((void *) (SYS_CLK_TIMER_BASE + AVALON_TIM_PERIODL), (TIMER_CLOCK & 0xffffU));       /* 󥿡å 16bit */
	sil_wrw_iop((void *) (SYS_CLK_TIMER_BASE + AVALON_TIM_PERIODH), ((uint32) TIMER_CLOCK >> 16));  /* 󥿡å 16bit */

	/*
	 * ޡȡȥɡߵ
	 */
	sil_wrw_iop((void *) (SYS_CLK_TIMER_BASE + AVALON_TIM_CONTROL), AVALON_TIM_CONTROL_START
				| AVALON_TIM_CONTROL_CONT | AVALON_TIM_CONTROL_ITO);
}

/*
 *  ޤ߽
 */
void
target_timer_terminate(void)
{
	/*  */
	sil_wrw_iop((void *) (SYS_CLK_TIMER_BASE + AVALON_TIM_CONTROL), AVALON_TIM_CONTROL_STOP);

	/* ׵Υꥢ */
	sil_wrw_iop((void *) (SYS_CLK_TIMER_BASE + AVALON_TIM_STATUS), 0x00U);
}

/*
 *  target_timer.cfgINCLUDEʤн
 */
#ifndef SysTimerCnt
#define SysTimerCnt		UINT_C(0)
#endif /* SysTimerCnt */

/*
 *  ޳ߥϥɥ
 */
ISR(target_timer_hdr)
{
	StatusType ercd;

	/* TOӥåȤΥꥢ */
	sil_wrw_iop((void *) (SYS_CLK_TIMER_BASE + AVALON_TIM_STATUS), 0x00U);

	/* current_time򹹿 */
	current_time++;

	/*
	 *  󥿲ûν¹
	 */
	ercd = IncrementCounter(SysTimerCnt);
	/* 顼꥿ξϥåȥ */
	if (ercd != E_OK) {
		ShutdownOS(ercd);
	}
}
