/*
 *  TOPPERS ATK2
 *      Toyohashi Open Platform for Embedded Real-Time Systems
 *      Automotive Kernel Version 2
 *
 *  Copyright (C) 2008-2013 by Center for Embedded Computing Systems
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *  Copyright (C) 2011-2013 by FUJISOFT INCORPORATED, JAPAN
 *  Copyright (C) 2011-2013 by FUJITSU VLSI LIMITED, JAPAN
 *  Copyright (C) 2011-2013 by NEC Communication Systems, Ltd., JAPAN
 *  Copyright (C) 2011-2013 by Panasonic Advanced Technology Development Co., Ltd., JAPAN
 *  Copyright (C) 2011-2013 by Renesas Electronics Corporation, JAPAN
 *  Copyright (C) 2011-2013 by Sunny Giken Inc., JAPAN
 *  Copyright (C) 2011-2013 by TOSHIBA CORPORATION, JAPAN
 *  Copyright (C) 2011-2013 by Witz Corporation, JAPAN
 *
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 *
 *  $Id: prc_mpu.c 7253 2013-03-27 12:02:55Z fujitsu-wada $
 */

/*
 *		ץå¸⥸塼Nios2ѡ
 */
#include "kernel_impl.h"
#include "nios2_mpu.h"
#include "osap.h"

/*
 *  MPUꤷƤ륹åͭ륿TCB
 */
void *p_ctxstk;

/* ؿΥץȥ */
static void prc_init_mpu_set(void);
LOCAL_INLINE boolean chk_adr_main(MemoryStartAddressType sadr1, MemoryStartAddressType eadr1, MemoryStartAddressType sadr2, MemoryStartAddressType eadr2);

/*
 *  nios2_mpu.h˥ץȥ֤٤OSAPINIB
 *  ʤΤǡѥ뤬̤ʤᤳ֤
 */
extern void prc_set_osap_mpu(const OSAPINIB *p_osapinib);

/*
 *  MPUꤷƤOSAP
 */
const void *p_ctxosap;

void
prc_set_osap_mpu(const OSAPINIB *p_osapinib)
{
	static uint8		tnum_set_inst_region;
	static uint8		tnum_set_data_region;
	const OSAPMPUINFOB	*mpuinfo;
	MPUINFOB			set_mpu;
	uint8				i;

	if (p_osapinib != (const OSAPINIB *) p_ctxosap) {
		p_ctxosap = (const void *) p_osapinib;

#ifndef OMIT_OSAPMPUINFOB
		mpuinfo = &(p_osapinib->osap_mpu);
#endif /* OMIT_OSAPMPUINFOB */

		for (i = 0U; i < (mpuinfo->tnum_inst_region + mpuinfo->tnum_data_region); i++) {
			prc_set_mpu(&(mpuinfo->p_mpu_region[i]));
		}
		for (i = mpuinfo->tnum_inst_region; i < tnum_set_inst_region; i++) {
			set_mpu.mpubase = NIOS2_INST_MPUBASE(i, 0U);
			set_mpu.mpuacc = NIOS2_MPUACC(0U, 0U);
			prc_set_mpu(&set_mpu);
		}
		tnum_set_inst_region = mpuinfo->tnum_inst_region;

		for (i = mpuinfo->tnum_data_region; i < tnum_set_data_region; i++) {
			set_mpu.mpubase = NIOS2_DATA_MPUBASE(NIOS2_MPU_PRV_DATA_REGION_START + i, 0U);
			set_mpu.mpuacc = NIOS2_MPUACC_DATA(0U, 0U);
			prc_set_mpu(&set_mpu);
		}
		tnum_set_data_region = mpuinfo->tnum_data_region;
	}
}

/*
 *  MPU
 */
static void
prc_init_mpu_set(void)
{
	MPUINFOB	mpuinfo;
	uint32		i;
	uint8		j;

	for (i = 0U; i < (NIOS2_MPU_INST_MAX_NUM - 1U); i++) {
		mpuinfo.mpubase = NIOS2_INST_MPUBASE(i, 0U);
		mpuinfo.mpuacc = NIOS2_MPUACC(0U, 0U);
		prc_set_mpu(&mpuinfo);
	}
	for (i = 0U; i < (NIOS2_MPU_DATA_MAX_NUM - 1U); i++) {
		mpuinfo.mpubase = NIOS2_DATA_MPUBASE(i, 0U);
		mpuinfo.mpuacc = NIOS2_MPUACC_DATA(0U, 0U);
		prc_set_mpu(&mpuinfo);
	}

	/*
	 *  Хå饦ΰMPU쥸
	 */
	mpuinfo.mpubase = NIOS2_INST_MPUBASE(NIOS2_MPU_BKGND_CODE_REGION, BG_CODE_START);
	mpuinfo.mpuacc = NIOS2_MPUACC(NIOS2_MPU_PERM_SYS_EXC_USR_NEX, BG_CODE_END);
	prc_set_mpu(&mpuinfo);

	mpuinfo.mpubase = NIOS2_DATA_MPUBASE(NIOS2_MPU_BKGND_DATA_REGION, BG_DATA_START);
	mpuinfo.mpuacc = NIOS2_MPUACC_DATA(NIOS2_MPU_PERM_SYS_RW_USR_NO, BG_DATA_END);
	prc_set_mpu(&mpuinfo);

	for (j = 0U; j < tnum_shared_region; j++) {
		prc_set_mpu(&(shared_region[j]));
	}
}

/*
 *  MPU
 */
void
prc_init_mpu(void)
{
	/*
	 *  MPUꤷƤ륹åͭ륿TCB
	 *  ¸ߤʤΤǡNULL˽
	 */
	p_ctxstk = NULL;

	p_ctxosap = NULL;

	/* MPU ̵ */
	mpu_disable();

	/*
	 *  MPU
	 */
	prc_init_mpu_set();

	/* MPU ͭ */
	mpu_enable();
}

/*
 *  ϰϥåؿ
 *   sadr1  eadr1 ϰϴ֤ sadr2  eadr2  뤫å
 */
LOCAL_INLINE boolean
chk_adr_main(MemoryStartAddressType sadr1, MemoryStartAddressType eadr1, MemoryStartAddressType sadr2, MemoryStartAddressType eadr2)
{
	MemorySizeType	end_adr1 = (MemorySizeType) eadr1;
	MemorySizeType	end_adr2 = (MemorySizeType) eadr2;

	/* eadr ˤϽüɥ쥹+1 ǼƤΤ ӻ -1 */
	return((sadr1 <= sadr2) && (sadr1 <= (MemoryStartAddressType) (end_adr2 - 1U)) &&
		   ((MemoryStartAddressType) (end_adr1 - 1U) >= sadr2) &&
		   ((MemoryStartAddressType) (end_adr1 - 1U) >= (MemoryStartAddressType) (end_adr2 - 1U)));
}

/*
 *  MPU¸Υå
 *    OSץꥱˤƥХåɤå
 */

AccessType
probe_trusted_osap_mem(const MemoryStartAddressType sadr, const MemoryStartAddressType eadr)
{
	AccessType ercd = NO_ACCESS;

	ercd |= (chk_adr_main((MemoryStartAddressType) BG_CODE_START, (MemoryStartAddressType) BG_CODE_END, sadr, eadr) != FALSE) ? AP_Executable : NO_ACCESS;
	ercd |= (chk_adr_main((MemoryStartAddressType) BG_DATA_START, (MemoryStartAddressType) BG_DATA_END, sadr, eadr) != FALSE) ? (AP_Writable | AP_Readable) : NO_ACCESS;

	return(ercd);
}
