/*
 *  TOPPERS ATK2
 *      Toyohashi Open Platform for Embedded Real-Time Systems
 *      Automotive Kernel Version 2
 *
 *  Copyright (C) 2011-2013 by Center for Embedded Computing Systems
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *  Copyright (C) 2011-2013 by FUJISOFT INCORPORATED, JAPAN
 *  Copyright (C) 2011-2013 by FUJITSU VLSI LIMITED, JAPAN
 *  Copyright (C) 2011-2013 by NEC Communication Systems, Ltd., JAPAN
 *  Copyright (C) 2011-2013 by Panasonic Advanced Technology Development Co., Ltd., JAPAN
 *  Copyright (C) 2011-2013 by Renesas Electronics Corporation, JAPAN
 *  Copyright (C) 2011-2013 by Sunny Giken Inc., JAPAN
 *  Copyright (C) 2011-2013 by TOSHIBA CORPORATION, JAPAN
 *  Copyright (C) 2011-2013 by Witz Corporation, JAPAN
 *
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 *
 *  $Id: Os.h 7259 2013-03-28 03:55:11Z fsi-dankei $
 */

/*
 *		ATK2 OSإåե
 *
 *  ATK2ݡȤ륷ƥॵӥȡɬפʥǡ
 *  ޥޤإåե
 *
 *  ֥Υե뤫餳Υե򥤥󥯥롼ɤ
 *  ϡTOPPERS_MACRO_ONLYƤ
 *  ˤꡤޥʳ褦ˤʤäƤ
 *
 *  Υե򥤥󥯥롼ɤ˥󥯥롼ɤƤ٤ե
 *  Ϥʤ
 */

#ifndef TOPPERS_OS_H
#define TOPPERS_OS_H

/*
 *  ̤Υǡޥ
 */
#include "Std_Types.h"
#include "MemMap.h"
#include "Rte_Os_Type.h"

#if !defined(TOPPERS_CFG1_OUT) && !defined(OMIT_INCLUDE_OS_CFG)
#include "Os_Cfg.h"
#endif

/*
 *  åȰ¸
 */
#include "target_kernel.h"

#ifndef TOPPERS_MACRO_ONLY

/*
 *  ǡ
 */

/*
 *  ֹ֥η
 */
typedef uint8	TaskStateType;                  /*  */
typedef uint32	EventMaskType;                  /* ٥ȥޥ */
typedef uint32	TickType;                       /* ͡ʥƥå*/
typedef uint32	AppModeType;                    /* ץꥱ⡼ */
typedef uint8	OSServiceIdType;                /* ƥॵӥID */
typedef uint8	ScheduleTableStatusType;        /* 塼ơ֥ */
typedef uint8	ProtectionReturnType;           /* ץƥեå֤ */
typedef uintptr	MemorySizeType;                 /* ΰ襵 */
typedef uint8	ApplicationType;                /* OSץꥱID */
typedef uint8	ObjectTypeType;                 /* OS֥ȼ */
typedef uint8	ApplicationStateType;           /* OSץꥱ */
typedef uint8	AccessType;                     /* ΰ襢 */
typedef boolean	ObjectAccessType;               /* OS֥ȥ */

typedef struct {
	TickType	maxallowedvalue;                /* 󥿻κ */
	TickType	ticksperbase;                   /* OSǤϻѤ桼ͳ˻Ѥ */
	TickType	mincycle;                       /* κǾ */
} AlarmBaseType;

/*
 *  Ŭ뤿ᡤ¸Ǥ뷿
 */
#ifndef OMIT_DATA_TYPE
typedef uint32	TimeType;                       /*  */
typedef uint32	AlarmType;                      /* 顼ID */
typedef uint32	ResourceType;                   /* ꥽ID */
typedef uint32	TaskType;                       /* ID */
typedef uint32	ISRType;                        /* ISR ID */
typedef uint32	CounterType;                    /* ID */
typedef uint32	ScheduleTableType;              /* 塼ơ֥ID */
typedef float32	PhysicalTimeType;               /* ʥƥå֤˴ѡ˻ */
typedef uint32	TrustedFunctionIndexType;       /* Trusted Function Index */
#endif /* OMIT_DATA_TYPE */

typedef AlarmBaseType *				AlarmBaseRefType;
typedef TaskType *					TaskRefType;
typedef TaskStateType *				TaskStateRefType;
typedef EventMaskType *				EventMaskRefType;
typedef TickType *					TickRefType;
typedef ScheduleTableStatusType *	ScheduleTableStatusRefType;
typedef ApplicationStateType *		ApplicationStateRefType;
typedef void *						MemoryStartAddressType;             /* ΰƬ */
typedef void *						TrustedFunctionParameterRefType;    /* Trusted Function Parameter */

/*
 *  ݸȿ򵯤ñ̤η
 */
typedef uint8 FaultyContextType;

/*
 *  OS֥ѤΥޥ
 */
#define DeclareTask(TaskIdentifier)
#define DeclareResource(ResourceIdentifier)
#define DeclareEvent(EventIdentifier)
#define DeclareAlarm(AlarmIdentifier)

/*
 *  ᥤ롼ѤΥޥ
 */
#define TASK(TaskName)		void TaskMain ## TaskName(void)
#define ISR(ISRName)		void ISRMain ## ISRName(void)
#define C1ISR(ISRName)		void C1ISRMain ## ISRName(void)

#define TRUSTEDFUNCTION(TrustedFunctionName, FunctionIndex, FunctionParams)	\
	StatusType TrustedFunctionName(											\
		TrustedFunctionIndexType FunctionIndex,								\
		TrustedFunctionParameterRefType FunctionParams						\
		)

/*
 *  ΰݤΤη
 */
#ifndef TOPPERS_STK_T
#define TOPPERS_STK_T	sintptr
#endif /* TOPPERS_STK_T */
typedef	TOPPERS_STK_T StackType;    /* åΰݤ뤿η */

/*
 *  ƥॵӥѥ᡼Τ
 */
typedef union {
	TaskType						tskid;
	TaskRefType						p_tskid;
	TaskStateRefType				p_stat;
	ResourceType					resid;
	EventMaskType					mask;
	EventMaskRefType				p_mask;
	AlarmType						almid;
	AlarmBaseRefType				p_info;
	TickRefType						p_tick;
	TickRefType						p_val;
	TickRefType						p_eval;
	TickType						incr;
	TickType						cycle;
	TickType						start;
	AppModeType						mode;
	CounterType						cntid;
	ScheduleTableType				schtblid;
	TickType						offset;
	ScheduleTableType				schtblid_from;
	ScheduleTableType				schtblid_to;
	ScheduleTableStatusRefType		p_schtblstate;
	StatusType						error;
	ISRType							isrid;
	TrustedFunctionIndexType		tfnid;
	TrustedFunctionParameterRefType	tfnpr;
	MemoryStartAddressType			adr;
	MemorySizeType					sz;
	ApplicationType					applid;
	ApplicationStateRefType			p_appstat;
} _ErrorHook_Par;


/*
 *  ΰݤΤΥޥ
 *
 *  ʲTOPPERS_COUNT_SZTOPPERS_ROUND_SZϡunit2ζҾǤ
 *  뤳ȤꤷƤ롥
 */
#ifndef TOPPERS_COUNT_SZ
#define TOPPERS_COUNT_SZ(sz, unit)	(((sz) + (unit) - (1U)) / (unit))
#endif /* TOPPERS_COUNT_SZ */
#ifndef TOPPERS_ROUND_SZ
#define TOPPERS_ROUND_SZ(sz, unit)	(((sz) + (unit) - (1U)) & (~((unit) - (1U))))
#endif /* TOPPERS_ROUND_SZ */

#define COUNT_STK_T(sz)		(TOPPERS_COUNT_SZ((sz), sizeof(StackType)))
#define ROUND_STK_T(sz)		(TOPPERS_ROUND_SZ((sz), sizeof(StackType)))

/*
 *  եå롼
 */
#ifdef CFG_USE_SYSTEM_ERRORHOOK
extern void ErrorHook(StatusType Error);
#endif /* CFG_USE_SYSTEM_ERRORHOOK */

#ifdef CFG_USE_PRETASKHOOK
extern void PreTaskHook(void);
#endif /* CFG_USE_PRETASKHOOK */

#ifdef CFG_USE_POSTTASKHOOK
extern void PostTaskHook(void);
#endif /* CFG_USE_POSTTASKHOOK */

#ifdef CFG_USE_SYSTEM_STARTUPHOOK
extern void StartupHook(void);
#endif /* CFG_USE_SYSTEM_STARTUPHOOK */

#ifdef CFG_USE_SYSTEM_SHUTDOWNHOOK
extern void ShutdownHook(StatusType Error);
#endif /* CFG_USE_SYSTEM_SHUTDOWNHOOK */

#ifdef CFG_USE_PROTECTIONHOOK
extern ProtectionReturnType ProtectionHook(StatusType FatalError);
#endif /* CFG_USE_PROTECTIONHOOK */

/*
 *  饤֥󶡤륷ƥॵӥ
 */
extern ObjectAccessType CheckObjectAccess(ApplicationType ApplID, ObjectTypeType ObjectType, ...);
extern ApplicationType CheckObjectOwnership(ObjectTypeType ObjectType, ...);

/*
 *  եֹ̾λѤѿ
 */
extern const char8	*fatal_file_name;   /* ե̾ */
extern sint32		fatal_line_num;     /* ֹ */

#endif /* TOPPERS_MACRO_ONLY */

/*
 *  ƥॵӥƽФΤ
 */
#include "kernel_fncode.h"              /* ǽɤ */
#include "svc_funccall.h"               /* ؿƽФˤƽФ */
#include "target_svc.h"                 /* եȥߤˤƽФ */

/*
 *  OSΥ顼
 */
#define E_OS_ACCESS							UINT_C(1)
#define E_OS_CALLEVEL						UINT_C(2)
#define E_OS_ID								UINT_C(3)
#define E_OS_LIMIT							UINT_C(4)
#define E_OS_NOFUNC							UINT_C(5)
#define E_OS_RESOURCE						UINT_C(6)
#define E_OS_STATE							UINT_C(7)
#define E_OS_VALUE							UINT_C(8)
#define E_OS_SERVICEID						UINT_C(9)
#define E_OS_ILLEGAL_ADDRESS				UINT_C(10)
#define E_OS_MISSINGEND						UINT_C(11)
#define E_OS_DISABLEDINT					UINT_C(12)
#define E_OS_STACKFAULT						UINT_C(13)
#define E_OS_PROTECTION_MEMORY				UINT_C(14)
#define E_OS_PROTECTION_TIME_TASK			UINT_C(15)
#define E_OS_PROTECTION_TIME_ISR			UINT_C(16)
#define E_OS_PROTECTION_ARRIVAL_TASK		UINT_C(17)
#define E_OS_PROTECTION_ARRIVAL_ISR			UINT_C(18)
#define E_OS_PROTECTION_LOCKED_RESOURCE		UINT_C(19)
#define E_OS_PROTECTION_LOCKED_OSINT		UINT_C(20)
#define E_OS_PROTECTION_LOCKED_ALLINT		UINT_C(21)
#define E_OS_PROTECTION_EXCEPTION			UINT_C(22)
#define E_OS_PROTECTION_FATAL				UINT_C(23)
#define E_OS_MODE							UINT_C(24)
#define E_OS_SHUTDOWN_FATAL					UINT_C(25)
#define OS_E_PARAM_POINTER					UINT_C(26)
#define E_OS_SYS_ASSERT_FATAL				UINT_C(27)
#define E_OS_STACKINSUFFICIENT              UINT_C(28)

#define ERRCODE_NUM							UINT_C(28) /* 顼ɿ */

/*
 *  ¾
 */
#define UINT32_INVALID		((uint32) 0xffffffff)
#define UINT8_INVALID		((uint8) 0xff)

#define SUSPENDED			((TaskStateType) 0) /* ٻ߾ */
#define RUNNING				((TaskStateType) 1) /* ¹Ծ */
#define READY				((TaskStateType) 2) /* ¹Բǽ */
#define WAITING				((TaskStateType) 3) /* Ԥ */

/*
 *  Ŭ뤿ᡤ¸Ǥκɬ
 */
#ifndef OMIT_DATA_TYPE
#define	INVALID_TASK			((TaskType) UINT32_INVALID)
#define	INVALID_ISR				((ISRType) UINT32_INVALID)
#endif /* OMIT_DATA_TYPE */
#define INVALID_APPMODETYPE		((AppModeType) UINT32_INVALID)
#define INVALID_OSAPPLICATION	((ApplicationType) UINT8_INVALID)

/*
 *  塼ơ֥Υơ
 */
#define SCHEDULETABLE_STOPPED					((ScheduleTableStatusType) 0x01)
#define SCHEDULETABLE_NEXT						((ScheduleTableStatusType) 0x02)
#define SCHEDULETABLE_WAITING					((ScheduleTableStatusType) 0x04)
#define SCHEDULETABLE_RUNNING					((ScheduleTableStatusType) 0x08)
#define SCHEDULETABLE_RUNNING_AND_SYNCHRONOUS	((ScheduleTableStatusType) 0x10)

/*
 *  OSץꥱξ
 */
#define APPLICATION_ACCESSIBLE	((ApplicationStateType) 0)  /* Ѳǽ */
#define APPLICATION_RESTARTING	((ApplicationStateType) 1)  /* Ƶư */
#define APPLICATION_TERMINATED	((ApplicationStateType) 2)  /* ץꥱλ */

/*
 *  
 */
#define ACCESS		(TRUE)
#define	NO_ACCESS	(FALSE)

/*
 *  ƥॵӥID
 */
#define OSServiceId_GetActiveApplicationMode	((OSServiceIdType) 0)
#define OSServiceId_StartOS						((OSServiceIdType) 1)
#define OSServiceId_ShutdownOS					((OSServiceIdType) 2)
#define OSServiceId_ActivateTask				((OSServiceIdType) 3)
#define OSServiceId_TerminateTask				((OSServiceIdType) 4)
#define OSServiceId_ChainTask					((OSServiceIdType) 5)
#define OSServiceId_Schedule					((OSServiceIdType) 6)
#define OSServiceId_GetTaskID					((OSServiceIdType) 7)
#define OSServiceId_GetTaskState				((OSServiceIdType) 8)
#define OSServiceId_EnableAllInterrupts			((OSServiceIdType) 9)
#define OSServiceId_DisableAllInterrupts		((OSServiceIdType) 10)
#define OSServiceId_ResumeAllInterrupts			((OSServiceIdType) 11)
#define OSServiceId_SuspendAllInterrupts		((OSServiceIdType) 12)
#define OSServiceId_ResumeOSInterrupts			((OSServiceIdType) 13)
#define OSServiceId_SuspendOSInterrupts			((OSServiceIdType) 14)
#define OSServiceId_GetISRID					((OSServiceIdType) 15)
#define OSServiceId_SetEvent					((OSServiceIdType) 16)
#define OSServiceId_ClearEvent					((OSServiceIdType) 17)
#define OSServiceId_GetEvent					((OSServiceIdType) 18)
#define OSServiceId_WaitEvent					((OSServiceIdType) 19)
#define OSServiceId_GetResource					((OSServiceIdType) 20)
#define OSServiceId_ReleaseResource				((OSServiceIdType) 21)
#define OSServiceId_IncrementCounter			((OSServiceIdType) 22)
#define OSServiceId_GetCounterValue				((OSServiceIdType) 23)
#define OSServiceId_GetElapsedValue				((OSServiceIdType) 24)
#define OSServiceId_GetAlarmBase				((OSServiceIdType) 25)
#define OSServiceId_GetAlarm					((OSServiceIdType) 26)
#define OSServiceId_SetRelAlarm					((OSServiceIdType) 27)
#define OSServiceId_SetAbsAlarm					((OSServiceIdType) 28)
#define OSServiceId_CancelAlarm					((OSServiceIdType) 29)
#define OSServiceId_StartScheduleTableRel		((OSServiceIdType) 30)
#define OSServiceId_StartScheduleTableAbs		((OSServiceIdType) 31)
#define OSServiceId_StopScheduleTable			((OSServiceIdType) 32)
#define OSServiceId_NextScheduleTable			((OSServiceIdType) 33)
#define OSServiceId_GetScheduleTableStatus		((OSServiceIdType) 34)
#define OSServiceId_TaskMissingEnd				((OSServiceIdType) 35)
#define OSServiceId_ISRMissingEnd				((OSServiceIdType) 36)
#define OSServiceId_HookMissingEnd				((OSServiceIdType) 37)
#define OSServiceId_GetApplicationID			((OSServiceIdType) 38)
#define OSServiceId_EnableInterruptSource		((OSServiceIdType) 39)
#define OSServiceId_DisableInterruptSource		((OSServiceIdType) 40)
#define OSServiceId_CallTrustedFunction			((OSServiceIdType) 41)
#define OSServiceId_CheckISRMemoryAccess		((OSServiceIdType) 42)
#define OSServiceId_CheckTaskMemoryAccess		((OSServiceIdType) 43)
#define OSServiceId_CheckTaskAccess				((OSServiceIdType) 44)
#define OSServiceId_CheckISRAccess				((OSServiceIdType) 45)
#define OSServiceId_CheckAlarmAccess			((OSServiceIdType) 46)
#define OSServiceId_CheckResourceAccess			((OSServiceIdType) 47)
#define OSServiceId_CheckCounterAccess			((OSServiceIdType) 48)
#define OSServiceId_CheckScheduleTableAccess	((OSServiceIdType) 49)
#define OSServiceId_CheckTaskOwnership			((OSServiceIdType) 50)
#define OSServiceId_CheckISROwnership			((OSServiceIdType) 51)
#define OSServiceId_CheckAlarmOwnership			((OSServiceIdType) 52)
#define OSServiceId_CheckCounterOwnership		((OSServiceIdType) 53)
#define OSServiceId_CheckScheduleTableOwnership	((OSServiceIdType) 54)
#define OSServiceId_GetApplicationState			((OSServiceIdType) 55)

#define OSServiceId_INVALID						((OSServiceIdType) 255)  /* ̵ʥƥॵӥID */

/*
 *  ݸȿ򵯤ñ̤
 */
#define FC_INVALID			UINT_C(0x00)        /* ݸȿ򵯤ΤǤʤ */
#define FC_TASK				UINT_C(0x01)        /* ݸȿ򵯤Τ */
#define FC_C2ISR			UINT_C(0x02)        /* ݸȿ򵯤ΤC2ISR */
#define FC_SYSTEM_HOOK		UINT_C(0x03)        /* ݸȿ򵯤ΤƥΥեå */
#define FC_OSAP_HOOK		UINT_C(0x04)        /* ݸȿ򵯤ΤOSAPͭΥեå */
#define FC_TRUSTED_FUNC		UINT_C(0x05)        /* ݸȿ򵯤Τؿ */

/*
 *  ƥॵӥѥ᡼Τ
 */
#ifndef TOPPERS_MACRO_ONLY

/*
 *  顼եåOFFӥIDȥѥ᡼OFFˤʤ
 */
#ifdef CFG_USE_ERRORHOOK

#ifdef CFG_USE_GETSERVICEID
extern OSServiceIdType	_errorhook_svcid;
#endif /* CFG_USE_GETSERVICEID */

#ifdef CFG_USE_PARAMETERACCESS
extern _ErrorHook_Par	errorhook_par1;
extern _ErrorHook_Par	errorhook_par2;
extern _ErrorHook_Par	errorhook_par3;
#endif /* CFG_USE_PARAMETERACCESS */

#endif /* CFG_USE_ERRORHOOK */

#endif /* TOPPERS_MACRO_ONLY */

/*
 *  顼եåOFFӥIDȥѥ᡼OFFˤʤ
 */
#ifdef CFG_USE_ERRORHOOK

/*
 *  ޥ
 */
#ifdef CFG_USE_GETSERVICEID
#define OSErrorGetServiceId()				(_errorhook_svcid)
#endif /* CFG_USE_GETSERVICEID */

#ifdef CFG_USE_PARAMETERACCESS
#define OSError_StartOS_Mode()									(errorhook_par1.mode)
#define OSError_ActivateTask_TaskID()							(errorhook_par1.tskid)
#define OSError_ChainTask_TaskID()								(errorhook_par1.tskid)
#define OSError_GetTaskID_TaskID()								(errorhook_par1.p_tskid)
#define OSError_GetTaskState_TaskID()							(errorhook_par1.tskid)
#define OSError_GetTaskState_State()							(errorhook_par2.p_stat)
#define OSError_GetResource_ResID()								(errorhook_par1.resid)
#define OSError_ReleaseResource_ResID()							(errorhook_par1.resid)
#define OSError_SetEvent_TaskID()								(errorhook_par1.tskid)
#define OSError_SetEvent_Mask()									(errorhook_par2.mask)
#define OSError_ClearEvent_Mask()								(errorhook_par1.mask)
#define OSError_GetEvent_TaskID()								(errorhook_par1.tskid)
#define OSError_GetEvent_Event()								(errorhook_par2.p_mask)
#define OSError_WaitEvent_Mask()								(errorhook_par1.mask)
#define OSError_GetAlarmBase_AlarmID()							(errorhook_par1.almid)
#define OSError_GetAlarmBase_Info()								(errorhook_par2.p_info)
#define OSError_GetAlarm_AlarmID()								(errorhook_par1.almid)
#define OSError_GetAlarm_Tick()									(errorhook_par2.p_tick)
#define OSError_SetRelAlarm_AlarmID()							(errorhook_par1.almid)
#define OSError_SetRelAlarm_increment()							(errorhook_par2.incr)
#define OSError_SetRelAlarm_cycle()								(errorhook_par3.cycle)
#define OSError_SetAbsAlarm_AlarmID()							(errorhook_par1.almid)
#define OSError_SetAbsAlarm_start()								(errorhook_par2.start)
#define OSError_SetAbsAlarm_cycle()								(errorhook_par3.cycle)
#define OSError_CancelAlarm_AlarmID()							(errorhook_par1.almid)
#define OSError_IncrementCounter_CounterID()					(errorhook_par1.cntid)
#define OSError_GetCounterValue_CounterID()						(errorhook_par1.cntid)
#define OSError_GetCounterValue_Value()							(errorhook_par2.p_val)
#define OSError_GetElapsedValue_CounterID()						(errorhook_par1.cntid)
#define OSError_GetElapsedValue_Value()							(errorhook_par2.p_val)
#define OSError_GetElapsedValue_ElapsedValue()					(errorhook_par3.p_eval)
#define OSError_StartScheduleTableRel_ScheduleTableID()			(errorhook_par1.schtblid)
#define OSError_StartScheduleTableRel_Offset()					(errorhook_par2.offset)
#define OSError_StartScheduleTableAbs_ScheduleTableID()			(errorhook_par1.schtblid)
#define OSError_StartScheduleTableAbs_Start()					(errorhook_par2.start)
#define OSError_StopScheduleTable_ScheduleTableID()				(errorhook_par1.schtblid)
#define OSError_NextScheduleTable_ScheduleTableID_From()		(errorhook_par1.schtblid_from)
#define OSError_NextScheduleTable_ScheduleTableID_To()			(errorhook_par2.schtblid_to)
#define OSError_GetScheduleTableStatus_ScheduleTableID()		(errorhook_par1.schtblid)
#define OSError_GetScheduleTableStatus_ScheduleStatus()			(errorhook_par2.p_schtblstate)
#define OSError_ShutdownOS_Error()								(errorhook_par1.error)
#define OSError_DisableInterruptSource_DisableISR()				(errorhook_par1.isrid)
#define OSError_EnableInterruptSource_EnableISR()				(errorhook_par1.isrid)
#define OSError_GetApplicationState_Application()				(errorhook_par1.applid)
#define OSError_GetApplicationState_Value()						(errorhook_par2.p_appstat)
#define OSError_CallTrustedFunction_FunctionIndex()				(errorhook_par1.tfnid)
#define OSError_CallTrustedFunction_FunctionParams()			(errorhook_par2.tfnpr)
#define OSError_CheckISRMemoryAccess_ISRID()					(errorhook_par1.isrid)
#define OSError_CheckISRMemoryAccess_Address()					(errorhook_par2.adr)
#define OSError_CheckISRMemoryAccess_Size()						(errorhook_par3.sz)
#define OSError_CheckTaskMemoryAccess_TaskID()					(errorhook_par1.tskid)
#define OSError_CheckTaskMemoryAccess_Address()					(errorhook_par2.adr)
#define OSError_CheckTaskMemoryAccess_Size()					(errorhook_par3.sz)
#define OSError_CheckTaskAccess_ApplID()						(errorhook_par1.applid)
#define OSError_CheckTaskAccess_TaskID()						(errorhook_par2.tskid)
#define OSError_CheckISRAccess_ApplID()							(errorhook_par1.applid)
#define OSError_CheckISRAccess_ISRID()							(errorhook_par2.isrid)
#define OSError_CheckAlarmAccess_ApplID()						(errorhook_par1.applid)
#define OSError_CheckAlarmAccess_AlarmID()						(errorhook_par2.almid)
#define OSError_CheckResourceAccess_ApplID()					(errorhook_par1.applid)
#define OSError_CheckResourceAccess_ResID()						(errorhook_par2.resid)
#define OSError_CheckCounterAccess_ApplID()						(errorhook_par1.applid)
#define OSError_CheckCounterAccess_CounterID()					(errorhook_par2.cntid)
#define OSError_CheckScheduleTableAccess_ApplID()				(errorhook_par1.applid)
#define OSError_CheckScheduleTableAccess_ScheduleTableID()		(errorhook_par2.schtblid)
#define OSError_CheckTaskOwnership_TaskID()						(errorhook_par1.tskid)
#define OSError_CheckISROwnership_ISRID()						(errorhook_par1.isrid)
#define OSError_CheckAlarmOwnership_AlarmID()					(errorhook_par1.almid)
#define OSError_CheckCounterOwnership_CounterID()				(errorhook_par1.cntid)
#define OSError_CheckScheduleTableOwnership_ScheduleTableID()	(errorhook_par1.schtblid)


#endif /* CFG_USE_PARAMETERACCESS */

#endif /* CFG_USE_ERRORHOOK */

/*
 *  ץƥեåطΥޥ
 */
#define PRO_IGNORE					UINT_C(0x00)
#define PRO_SHUTDOWN				UINT_C(0x01)
#define PRO_TERMINATETASKISR		UINT_C(0x02)
#define PRO_TERMINATEAPPL			UINT_C(0x03)
#define PRO_TERMINATEAPPL_RESTART	UINT_C(0x04)

/*
 *  ꥢ¥åΤΥޥ
 */

/*
 *  ΰ 
 */

#define	AP_NoAccess		UINT_C(0x0)
#define	AP_Executable	UINT_C(0x1)
#define	AP_Readable		UINT_C(0x2)
#define	AP_Writable		UINT_C(0x4)
#define	AP_StackSpace	UINT_C(0x8)

/*
 *  åޥ
 */
#define	OSMEMORY_IS_READABLE(AccessType)	((AccessType) & AP_Readable)
#define	OSMEMORY_IS_WRITEABLE(AccessType)	((AccessType) & AP_Writable)
#define	OSMEMORY_IS_EXECUTABLE(AccessType)	((AccessType) & AP_Executable)
#define	OSMEMORY_IS_STACKSPACE(AccessType)	((AccessType) & AP_StackSpace)

/*
 *   ֥ȥ
 */
#define	OBJECT_TASK				UINT_C(0x01)
#define	OBJECT_ISR				UINT_C(0x02)
#define	OBJECT_ALARM			UINT_C(0x03)
#define	OBJECT_RESOURCE			UINT_C(0x04)
#define	OBJECT_COUNTER			UINT_C(0x05)
#define	OBJECT_SCHEDULETABLE	UINT_C(0x06)

/*
 *  С
 */
#define OS_SW_MAJOR_VERSION				UINT_C(1)   /* ץ饤䡼С */
#define OS_SW_MINOR_VERSION				UINT_C(0)
#define OS_SW_PATCH_VERSION				UINT_C(1)

#define OS_AR_RELEASE_MAJOR_VERSION		UINT_C(4)   /* AUTOSAR꡼С */
#define OS_AR_RELEASE_MINOR_VERSION		UINT_C(0)
#define OS_AR_RELEASE_REVISION_VERSION	UINT_C(3)


#define	TKERNEL_NAME	"TOPPERS/ATK2-SC3"  /* ͥ̾Ρȼ͡ */

#endif /* TOPPERS_OS_H */
