/*
 *  TOPPERS ATK2
 *      Toyohashi Open Platform for Embedded Real-Time Systems
 *      Automotive Kernel Version 2
 *
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2005-2013 by Center for Embedded Computing Systems
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *  Copyright (C) 2011-2013 by FUJISOFT INCORPORATED, JAPAN
 *  Copyright (C) 2011-2013 by FUJITSU VLSI LIMITED, JAPAN
 *  Copyright (C) 2011-2013 by NEC Communication Systems, Ltd., JAPAN
 *  Copyright (C) 2011-2013 by Panasonic Advanced Technology Development Co., Ltd., JAPAN
 *  Copyright (C) 2011-2013 by Renesas Electronics Corporation, JAPAN
 *  Copyright (C) 2011-2013 by Sunny Giken Inc., JAPAN
 *  Copyright (C) 2011-2013 by TOSHIBA CORPORATION, JAPAN
 *  Copyright (C) 2011-2013 by Witz Corporation, JAPAN
 *
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 *
 *  $Id: check.h 6837 2013-01-23 10:46:48Z fsi-dankei $
 */

/*
 *		顼åѥޥ
 */

#ifndef TOPPERS_CHECK_H
#define TOPPERS_CHECK_H

#include "Os_Cfg.h"
#include "memory.h"

/*
 * ѥåޥ
 */
#define CHECK_ERROR_ERCD(exp, error) \
	do {							 \
		if (!(exp)) {				 \
			ercd = (error);			 \
			goto error_exit;		 \
		}							 \
	} while (0)

#define CHECK_ERROR_NO_ERCD(exp) \
	do {						 \
		if (!(exp)) {			 \
			goto error_exit;	 \
		}						 \
	} while (0)

#define D_CHECK_ERROR_ERCD(exp, error) \
	do {							   \
		if (!(exp)) {				   \
			ercd = (error);			   \
			goto d_error_exit;		   \
		}							   \
	} while (0)

#define D_CHECK_ERROR_NO_ERCD(exp) \
	do {						   \
		if (!(exp)) {			   \
			goto d_error_exit;	   \
		}						   \
	} while (0)

/*
 *  ɸ२顼Υåޥ
 */
#define S_CHECK_ERROR(exp, error)		CHECK_ERROR_ERCD(exp, error)


#ifdef CFG_USE_ERRORHOOK
/*
 *  顼եå̵ͭˤ٥κ
 */
#define error_exit exit_errorhook
#define d_error_exit d_exit_errorhook

/*
 *  顼եåѤϥ顼ɤ
 */
#define S_N_CHECK_ERROR(exp, error)		CHECK_ERROR_ERCD(exp, error)

#else /* CFG_USE_ERRORHOOK */
/*
 *  顼եå̵ͭˤ٥κ
 */
#define error_exit exit_no_errorhook
#define d_error_exit d_exit_no_errorhook

/*
 *  顼եåѤʤϥ顼ɤʤ
 */
#define S_N_CHECK_ERROR(exp, error)		CHECK_ERROR_NO_ERCD(exp)

#endif /* CFG_USE_ERRORHOOK */


/* ʲΥåޥOSѤ */

/*
 *  顼ɤбޥ
 *   ɸ२顼
 */
#ifdef OMIT_STANDARD_DISALLINT

#define S_CHECK_DISALLINT()
#define S_N_CHECK_DISALLINT()

#else /* OMIT_STANDARD_DISALLINT */

#define S_CHECK_DISALLINT()								 \
	S_CHECK_ERROR(										 \
		((callevel_stat & TSYS_DISALLINT) == TSYS_NULL), \
		E_OS_DISABLEDINT								 \
		)
#define S_N_CHECK_DISALLINT()							 \
	S_N_CHECK_ERROR(									 \
		((callevel_stat & TSYS_DISALLINT) == TSYS_NULL), \
		E_OS_DISABLEDINT								 \
		)

#endif /* OMIT_STANDARD_DISALLINT */

#define S_CHECK_STATE(exp)				S_CHECK_ERROR(exp, E_OS_STATE)
#define S_N_CHECK_STATE(exp)			S_N_CHECK_ERROR(exp, E_OS_STATE)
#define S_CHECK_LIMIT(exp)				S_CHECK_ERROR(exp, E_OS_LIMIT)
#define S_N_CHECK_LIMIT(exp)			S_N_CHECK_ERROR(exp, E_OS_LIMIT)
#define S_D_CHECK_NOFUNC(exp)			D_CHECK_ERROR_ERCD(exp, E_OS_NOFUNC)
#define S_D_CHECK_STATE(exp)			D_CHECK_ERROR_ERCD(exp, E_OS_STATE)
#define S_D_CHECK_LIMIT(exp)			D_CHECK_ERROR_ERCD(exp, E_OS_LIMIT)

/*
 *  顼ɤбޥ
 *   ĥ顼
 */
#define CHECK_ACCESS(exp)				CHECK_ERROR_ERCD(exp, E_OS_ACCESS)
#define D_CHECK_ACCESS(exp)				D_CHECK_ERROR_ERCD(exp, E_OS_ACCESS)
#define CHECK_CALLEVEL(clmask)					  \
	CHECK_ERROR_ERCD(							  \
		((callevel_stat | (clmask)) == (clmask)), \
		E_OS_CALLEVEL							  \
		)
#define CHECK_NOFUNC(exp)				CHECK_ERROR_ERCD(exp, E_OS_NOFUNC)
#define CHECK_RESOURCE(exp)				CHECK_ERROR_ERCD(exp, E_OS_RESOURCE)
#define D_CHECK_STATE(exp)				D_CHECK_ERROR_ERCD(exp, E_OS_STATE)
#define CHECK_VALUE(exp)				CHECK_ERROR_ERCD(exp, E_OS_VALUE)
#define CHECK_DISABLEDINT()										\
	CHECK_ERROR_ERCD(											\
		((callevel_stat &										\
		  (TSYS_DISALLINT | TSYS_SUSALLINT | TSYS_SUSOSINT)) ==	\
		 TSYS_NULL												\
		),														\
		E_OS_DISABLEDINT										\
		)
#define CHECK_PARAM_POINTER(p_exp)		CHECK_ERROR_ERCD(((p_exp) != NULL), OS_E_PARAM_POINTER)
#define CHECK_ID(exp)					CHECK_ERROR_ERCD(exp, E_OS_ID)
#define CHECK_SERVICEID(exp)			CHECK_ERROR_ERCD(exp, E_OS_SERVICEID)
#define CHECK_ACS(btmp)												   \
	CHECK_ERROR_ERCD(												   \
		(run_trusted != FALSE) || ((p_runosap->btptn & (btmp)) != 0U), \
		E_OS_ACCESS													   \
		)
#define CHECK_ILLEGAL_ADDRESS(exp)		CHECK_ERROR_ERCD(exp, E_OS_ILLEGAL_ADDRESS)
#define CHECK_MEM_WRITE(p_var, type)	CHECK_ERROR_ERCD((PROBE_MEM_WRITE(p_var, type) != FALSE), E_OS_ILLEGAL_ADDRESS)
#define CHECK_MEM_RW(p_var, type)		CHECK_ERROR_ERCD((PROBE_MEM_RW(p_var, type) != FALSE), E_OS_ILLEGAL_ADDRESS)
#define CHECK_NO_ERCD(exp)				CHECK_ERROR_NO_ERCD(exp)

#endif /* TOPPERS_CHECK_H */
